function varargout = MOM_Load_11_3(varargin)
%
% Copyright 2012, Aristides Arrenberg and Bastian Hablitzel, University of Freiburg
%
%
% MOM_LOAD_11_3 MATLAB code for MOM_Load_11_3.fig
%      MOM_LOAD_11_3, by itself, creates a new MOM_LOAD_11_3 or raises the existing
%      singleton*.
%
%      H = MOM_LOAD_11_3 returns the handle to a new MOM_LOAD_11_3 or the handle to
%      the existing singleton*.
%
%      MOM_LOAD_11_3('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MOM_LOAD_11_3.M with the given input arguments.
%
%      MOM_LOAD_11_3('Property','Value',...) creates a new MOM_LOAD_11_3 or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before MOM_Load_11_3_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to MOM_Load_11_3_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".

%for pretectum
% in these recordings (121126), the stimulus is usually not
% turned off at any time. Instead the stimulus stops rotating
% inbetween CW and CCW rotations. (So regressors 5,6,7 =0 means
% just that velocity was equal to zero).
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MOM_Load_11_3

% Last Modified by GUIDE v2.5 09-Jul-2014 16:44:55

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @MOM_Load_11_3_OpeningFcn, ...
    'gui_OutputFcn',  @MOM_Load_11_3_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before MOM_Load_11_3 is made visible.
function MOM_Load_11_3_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to MOM_Load_11_3 (see VARARGIN)


% Choose default command line output for MOM_Load_11_3
handles.output = hObject;

% standard values for GUI elements

global precisesync mainR orthog frameTime usePixCorr tau velocitythresh FDRalpha usebinning selection AvailableRegs VisualStandardList OculomotorStandardList RegList automaticROI ROIradius

VisualStandardList={
    'Eye', 'BE', 'pos', 'Right';...
    'Eye', 'LE', 'pos', 'Right';...
    'Eye', 'RE', 'pos', 'Right';...
    'Stim', 'BE', 'vel', 'ConjCW';...
    'Stim', 'BE', 'normvel', 'ConjCW';...
    'Stim', 'BE', 'vel', 'ConjCCW';...
    'Stim', 'BE', 'normvel', 'ConjCCW';...
    'Stim', 'BE', 'vel', 'Div';...
    'Stim', 'BE', 'vel', 'Conv';...
    'Stim', 'LE', 'vel', 'NT';...
    'Stim', 'LE', 'vel', 'TN';...
    'Stim', 'RE', 'vel', 'NT';...
    'Stim', 'RE', 'vel', 'TN';...
    'Stim', 'BE', 'anyactive', '';...
    'Stim', 'BE', 'anyactiveDirSens', '';...
    'Stim', 'BE', 'onoffset', '';...
    'AvgFrFl', '','',''...
    };
VisualStandardList(:,2:end+1)=VisualStandardList;

for k=1:size(VisualStandardList,1)
    VisualStandardList(k,1)=strcat(VisualStandardList(k,2), VisualStandardList(k,3), VisualStandardList(k,4), VisualStandardList(k,5));
end

OculomotorStandardList={
    'eye', 'BE', 'pos', 'Right';...
    'eye', 'LE', 'pos', 'Right';...
    'eye', 'RE', 'pos', 'Right';...
    'eye', 'BE', 'rawvel', 'ConjCW';...
    'eye', 'BE', 'rawvel', 'ConjCCW';...
    'eye', 'BE', 'hivel', 'ConjCW';...
    'eye', 'BE', 'hivel', 'ConjCCW';...
    'eye', 'BE', 'lowvel', 'ConjCW';...
    'eye', 'BE', 'lowvel', 'ConjCCW';...
    'eye', 'BE', 'rawvel', 'Conv';...
    'eye', 'BE', 'rawvel', 'Div';...
    'eye', 'LE', 'rawvel', 'TN';...
    'eye', 'LE', 'rawvel', 'NT';...
    'eye', 'RE', 'rawvel', 'NT';...
    'eye', 'RE', 'rawvel', 'TN';...
    'AvgFrFl', '','',''};

OculomotorStandardList(:,2:end+1)=OculomotorStandardList;
for k=1:size(OculomotorStandardList,1)
    OculomotorStandardList(k,1)=strcat(OculomotorStandardList(k,2), OculomotorStandardList(k,3), OculomotorStandardList(k,4), OculomotorStandardList(k,5));
end
RegList=OculomotorStandardList;
set(handles.listbox_selectMainReg,'String',RegList(:,1));
set(handles.listbox_selectMainReg,'Value',1);

%Step1 parameters
tau=1.5;                                  % standard parameter set for GCaMP5G
set(handles.settau,'String',num2str(tau));
set(handles.edit_numoflayers, 'Enable', 'off','String', '2');
set(handles.text17, 'Enable', 'off');
numoflayers=str2double(get(handles.edit_numoflayers,'String'));
set(handles.popupmenu_layerselect, 'Enable', 'off', 'String', 1:numoflayers);
%Step2 parameters
frameTime=0.5;                            % frame rate of the 2P imaging 2Hz
set(handles.edit_frametime,'String',num2str(frameTime));
precisesync=1;
set(handles.chkbox_preciseframesync,'Value',precisesync);
mainR=1;
orthog=0;
set(handles.orthogonalize,'Value',orthog);
velocitythresh=10;
set(handles.edit_velthr,'String',num2str(velocitythresh));
%Step3 parameters
usePixCorr=0;
set(handles.chkbox_usepixcorr,'Value',usePixCorr);
FDRalpha=0.15;
set(handles.edit_FDRalpha,'String',FDRalpha);
usebinning=1;
set(handles.checkbox_binning,'Value',usebinning);
selection=cell(1,4);
automaticROI=1;
set(handles.checkbox_autoROIselect,'Value',automaticROI);
ROIradius=3;
set(handles.edit_ROIradius,'String',num2str(ROIradius));
showstimbarplot=0;
set(handles.checkbox_stimbarplot,'Value', showstimbarplot);


load('AvailableRegressors.mat');
AvailableRegs(:,2:end+1)=AvailableRegs;
for k=1:size(AvailableRegs,1)
    AvailableRegs(k,1)=strcat(AvailableRegs(k,2), AvailableRegs(k,3), AvailableRegs(k,4), AvailableRegs(k,5));
end

% Update handles structure
guidata(hObject, handles);


% UIWAIT makes MOM_Load_11_3 wait for user response (see UIRESUME)
% uiwait(handles.MainGUI);


% --- Outputs from this function are returned to the command line.
function varargout = MOM_Load_11_3_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in Load.
function Load_Callback(hObject, eventdata, handles)
% hObject    handle to Load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

clearvars -global images vid2 eyetrack eyetrack_pad pathname filename
global   pathname filename images vid2 eyetrack eyetrack_pad eyetrack_full AvgFrFl
set(handles.disp_ETfile, 'String', 'No file loaded');
set(handles.disp_Ca2video, 'String', 'No file loaded');

% LOAD EYETRACKING FILE
[filename, pathname,filesuccess] = uigetfile('*.txt');
if isempty(filename) || filesuccess==0
    errordlg('No valid eyetracking file selected.')
    return;
end
eyetrack_full=load([pathname filename]);
fprintf('\n');
disp(['Loaded eyetracking file ' [pathname, filename]]);
set(handles.disp_ETfile, 'String', filename);
imperiod=abs(diff(eyetrack_full(:,7)))>0.5;      % Column 7 y mirror signal
imperiod2=find(imperiod);

%Swap eyes as they are detected from below on MOM-setup; Column 5 now is left eye, column 6 right eye.

temp1=eyetrack_full(:,5);  
eyetrack_full(:,5)=eyetrack_full(:,6);
eyetrack_full(:,6)=temp1;

eyetrack=eyetrack_full(imperiod2(1):imperiod2(end),:);
eyetrack_pad=eyetrack_full(imperiod2(1):imperiod2(end),:);    % pad zeros for proper peak detection

% % % % % % % % % % % % % % % % % % % % % % % % % % % 
% LOAD MOVIE FILE
[filename, pathname, filesuccess] = uigetfile('*.avi');
if isempty(filename) || filesuccess==0
    errordlg('No valid video file selected.')
    return;
end
xyloObj = VideoReader([pathname filename]);
images = xyloObj.NumberOfFrames;
ydim = xyloObj.Height;
xdim = xyloObj.Width;

% Preallocate movie structure.
temp2(1:images) = ...
    struct('cdata', zeros(ydim, xdim, images, 'uint8'),...
    'colormap', []);
vid2=zeros(ydim,xdim,images, 'uint8');
% Read one frame at a time.

h=waitbar(0,'Loading video frames (VideoReader)');

for i = 1 : images
    temp2(i).cdata = read(xyloObj, i);
    
    try     
       vid2(:,:,i)=rgb2gray(temp2(i).cdata); %Matlab 2010
    catch
       vid2(:,:,i)=(temp2(i).cdata);         %Matlab 2014
    end    

    waitbar(i/images);
end
close(h);

%calculate mean frame fluorescence
AvgFrFl=mean(mean(vid2,1),2);
AvgFrFl=reshape(AvgFrFl,size(AvgFrFl,3),1,1);

%add minimal noise to overexposed pixels to avoid crashing the LR_cellfinder

[DiffZeroRow,DiffZeroCol]=find(sum(diff(vid2,1,3),3)==0);
for k=1:size(vid2,3) 
    vid2(DiffZeroRow,DiffZeroCol,k)=uint8(deal(vid2(DiffZeroRow,DiffZeroCol))+round(rand));
end

fprintf('\n');
disp(['Loaded video file ' [pathname, filename,]]);
fprintf('\n');
disp(['Number of loaded video frames: ' num2str(images)]);
set(handles.disp_Ca2video, 'String', filename);

% --- Executes on button press in CreateZscoreMap.
function CreateZscoreMap_Callback(hObject, eventdata, handles)
% hObject    handle to CreateZscoreMap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%clearvars -global -except precisesync mainR orthog frameTime usePixCorr filename pathname images vid2 eyetrack eyetrack_pad tau velocitythresh usebinning FDRalpha AvailableRegs VisualStandardList OculomotorStandardList RegList automaticROI
clearvars -global Rquad R G X q
global RegionStats Rquad R G X mainR orthog frameTime usePixCorr RegressorNames precisesync eyetrack filename pathname q images vid2 eyetrack_pad tau velocitythresh FDRalpha usebinning wasbinned RegList

disp(['Velocity threshold: ', num2str(velocitythresh)]);

if precisesync==0           % Use Ari's coarse synchronization mode(equidistant spacing)
    eyetrack_DS=eyetrack_pad(round(1:end/images:end),:);
    
elseif precisesync==1       % Use Bastian's precise synchronization mode(Y-mirror analog signal peak detection)
    peaktolerance=1.2;      %  maximum tolerance factor for peak intervals to differ from mean   
    minn=min(eyetrack_pad(:,7));
    maxx=max(eyetrack_pad(:,7));
    temp2=eyetrack_pad(:,7)>((maxx-minn)*4/6+minn);
    temp=diff(temp2);
    if temp2(1)==1
        temp(1)=1;
    end
    
    sta=find(temp==1);
    sto=find(temp==-1);
    if sta(1)>sto(1)
        sto(1)=[];      %  always starts with a peak
    end
    
    if sta(end)>sto(end)
        sta(end)=[];
    end
    peak_inds=round((sta+sto)/2);
    peaks(:,2)=eyetrack_pad(peak_inds,1);
    peaks(:,1)=1:length(peaks);
    peaks(:,3:4)=zeros(length(peaks),2);
    
    temp2=eyetrack_pad(:,7)<((maxx-minn)*2/6+minn);
    temp=diff(temp2);
    if temp2(1)==1
        temp(1)=1;
    end
    
    sta=find(temp==1);
    sto=find(temp==-1);
    if sta(1)>sto(1)
        sto(1)=[];      %  always starts with a peak
    end
    if sta(end)>sto(end)
        sta(end)=[];
    end
    valleys_inds=round((sta+sto)/2);
    valleys(:,2)=eyetrack_pad(valleys_inds,1);
    valleys(:,1)=1:length(valleys);
    valleys(:,3:4)=zeros(length(valleys),2);
    
    CAfr=mean([diff(valleys(:,2)); diff(peaks(:,2))]);   % mean Ca2+-imaging framerate
    
    %detect missing peaks and valleys
    
    errpeaks=find(diff(peaks(:,2))>peaktolerance*CAfr);                                       % index of last peak before missing ones
    errpeaks(:,2)=round((peaks(errpeaks(:,1)+1,2)-peaks(errpeaks(:,1),2))/CAfr')-1;           % number of missing peaks to insert
    errvalleys=find(diff(valleys(:,2))>peaktolerance*CAfr);                                   % index of last peak before missing ones
    errvalleys(:,2)=round((valleys(errvalleys(:,1)+1,2)-valleys(errvalleys(:,1),2))/CAfr')-1; % number of missing peaks to insert
    
    %Add missing peaks
    addpeaks=[];
    for n=1:size(errpeaks,1)
        for m=1:errpeaks(n,2)
            [~, array_position] = min(abs(eyetrack_pad(:,1)-(peaks(errpeaks(n,1),2)+m*CAfr)));
            if max(eyetrack_pad(array_position,1)==peaks(:,2))==0
                addpeaks=[addpeaks; [0 eyetrack_pad(array_position,1) 0 0]];
            end
        end
    end
    
    %Add missing valleys
    addvalleys=[];
    for n=1:size(errvalleys,1)
        for m=1:errvalleys(n,2)
            [~, array_position] = min(abs(eyetrack_pad(:,1)-(valleys(errvalleys(n,1),2)+m*CAfr)));
            if max(eyetrack_pad(array_position,1)==valleys(:,2))==0
                addvalleys=[addvalleys; [0 eyetrack_pad(array_position,1) 0 0]];
            end
        end
    end
    addeddelimiters=size(addpeaks,1)+size(addvalleys,1);
    disp(['Added ', num2str(addeddelimiters) ' missing frame delimiters']);
    
    if peaks(1,2)<valleys(1,2)
        peaks(1,:)=[];
        disp('Deleted first detected peak');
    end
    
    %combine peaks and valleys -> framelist
    extreme=sortrows([peaks; addpeaks; valleys; addvalleys],2);
    
    %% multi-layer mode
    if get(handles.checkbox_multilayer,'Value')
        numL=str2double(get(handles.edit_numoflayers,'String'));
        selL=get(handles.popupmenu_layerselect,'Value');
        tempL=1:numL:(size(extreme,1));
        extreme=extreme(tempL,:);
    end
    
    eyetrack_DS=zeros(size(extreme,1)-1,size(eyetrack_pad,2));
    for n=1:size(extreme,1)-1
        indd=find(eyetrack_pad(:,1)==extreme(n,2)):find(eyetrack_pad(:,1)==extreme(n+1,2));
        eyetrack_DS(n,1)= mean(eyetrack_pad(indd,1));
        for m=2:size(eyetrack_DS,2)
        eyetrack_DS(n,m)= median(eyetrack_pad(indd,m));
        end
    end
end

% end of precisesync loops

%% Downsampling evaluation plot
h=figure(7);
plot(eyetrack_pad(:,1),eyetrack_pad(:,7),'r'); %plot Analog in signal
hold on
try plot(peaks(:,2),-4,'gP'); catch; end       % plot detected peaks
try plot(valleys(:,2),-50,'bP'); catch; end    % plot detected valleys
try plot(addpeaks(:,2),-4,'rP'); catch; end    % plot added peaks
try plot(addvalleys(:,2),-50,'rP'); catch; end % plot added valleys
try plot(extreme(:,2),-20,'cP'); catch; end    % plot added valleys

plot(eyetrack_pad(:,1),[50+eyetrack_pad(:,5),30+eyetrack_pad(:,6)],'c'); %  plot mean eye positions at original framerate
plot(eyetrack_DS(:,1),[50+eyetrack_DS(:,5),30+eyetrack_DS(:,6)],'m*-');  %  plot (median-)downsampled mean eye positions
title('Evaluation plot for downsampling quality');
hold off
saveas(h,[pathname filename(1:end-4) '_framedetection.jpg'],'jpg');
saveas(h,[pathname filename(1:end-4) '_framedetection.fig'],'fig');

% Check if eyetracking data and video frames match
disp(['Number of expected eyetracking datapoints: ' num2str(size(eyetrack_DS,1))]);
fprintf('\n');
if size(eyetrack_DS,1)==size(vid2,3)
    disp('Success: Number of video frames matches eyetracking data.')
elseif size(vid2,3)-2 <= 2*(size(eyetrack_DS,1)-1) && 2*(size(eyetrack_DS,1)-1)<= size(vid2,3)
    err = MException('DataAlignChk:DoubleVidframes', ...
        'Twice as many video frames than indicated by Y-mirror signal. This could indicate that a second imaging channel was exported. Re-export and register the calcium imaging data.');
    throw(err)
else
    err = MException('DataAlignChk:Mismatch', ...
        'Number of video frames does not match Y-mirror signal in eyetracking data file. Make sure that corresponding data files were selected. Check video file integrity, number of frames and number of channels.');
    throw(err)
end    

%Generate Regressors
[R,RegressorNames,regressorConv]=makeRegressors(eyetrack_DS,RegList);

R=R(2:end,:);  % remove first timepoint to account for differential-based regressors

% Generate Movie Matrix X (first frame removed to match size of differential regressors)
wasbinned=[];
if usebinning==0
    X=double(vid2(:,:,2:end));
    wasbinned=0;
elseif usebinning==1
    X=double(imresize(vid2(:,:,2:end),0.5));
    wasbinned=1;
end

clear vid2;
G=R;
RegionStats=LRcellfinder_ari_onlyZscores_6(1,1,1,regressorConv);
LRcellfinder_ari_onlyplots2to8_2;
LRcellfinder_ari_onlyplot4and5;
savefigures_3;
tilefigs;
save([pathname filename(1:end-4) '_R_quadr' num2str(q) '.mat'],'R');


% --- Executes on button press in DrawROIs.
function DrawROIs_Callback(hObject, eventdata, handles)
% hObject    handle to DrawROIs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global RegionStats pathname filename q images mainR Go RegressorNames velocitythresh R showstimbarplot tau



LRcellfinder_onlyROIs_4automaticROIselect;
LRcellfinder_ari_onlyplots2to8_2;

h=figure(10);
clf
hold on
spacing=2;
scal=2;
for j=1:length(RegionStats)
    temp=(Go(:,mainR)-min(Go(:,mainR)))/(max(Go(:,mainR))-min(Go(:,mainR)));  %  normalized
    plot(temp-j*spacing,'r','LineWidth',2);
    plot(RegionStats(j).DFF/scal-j*spacing, 'LineWidth',2);
    temp2=(Go(:,1)-min(Go(:,1)))/(max(Go(:,1))-min(Go(:,1)));
    plot(temp2-j*spacing,'black','LineWidth',2);                              %  eye positions
    RegionStats(j).corrVec(1);
    
    strCell{1}=['cell ' num2str(j) ' '];
    for m=1:size(RegressorNames)
        strCell{m+1}=[ RegressorNames{m} '=' num2str(RegionStats(j).corrVec(m),'%1.2f') ' '];
        if mod(m,3)==0
        strCell{m+1}=[strCell{m+1} '\n'];
        end
    end
    textt=sprintf([strCell{:}]);
    text(images+50,-j*spacing+0.5,textt);
    xlim([0,images+600]);
end
currentMainReg=RegressorNames{mainR};

temp=['DFF-divided by ' num2str(scal) '  main Regressor=' RegressorNames(mainR)];
temp2=[];
for i=1:length(temp)
    temp2=strcat(temp2, temp(i));
end
title(temp2);
saveas(h,[[pathname filename(1:end-4)] '_fig10_quadr' num2str(q) '_mainReg=' currentMainReg '_DFF.jpg'],'jpg');
saveas(h,[[pathname filename(1:end-4)] '_fig10_quadr' num2str(q) '_mainReg=' currentMainReg '_DFF.fig'],'fig');
save([[pathname filename(1:end-4)] '_RegionStats_quadr' num2str(q) '_mainReg=' currentMainReg '.mat'],'RegionStats' ,'Go','RegressorNames','mainR','currentMainReg');

if showstimbarplot==1
stimbarplothandle=stimbarplot(R, RegionStats, RegressorNames); %figure 14
saveas(stimbarplothandle,[[pathname filename(1:end-4)] '_fig14' num2str(q) '_mainReg=' currentMainReg '.jpg'],'jpg');
saveas(stimbarplothandle,[[pathname filename(1:end-4)] '_fig14' num2str(q) '_mainReg=' currentMainReg '.fig'],'fig');
end

savefigures_3;

tilefigs;

% --- Executes on button press in orthogonalize.
function orthogonalize_Callback(hObject, eventdata, handles)
% hObject    handle to orthogonalize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global orthog
orthog=get(hObject,'Value');
% Hint: get(hObject,'Value') returns toggle state of orthogonalize

% --- Executes on button press in pushbutton_createRegList.
function pushbutton_createRegList_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_createRegList (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global AvailableRegs RegList

RegressorCellList=cell(1,size(AvailableRegs,1));
for l=1:size(AvailableRegs,1)
    RegressorCellList{1,l}=AvailableRegs{l,1};
end

[s,~] = choosebox('Name','Regressor selection',...
    'PromptString','Available regressors',...
    'SelectString','Selected regressors (1st=MainReg)',...
    'ListString',RegressorCellList);

RegList=AvailableRegs(s,2:5);
RegressorsFile=RegList;
[savefile, savepath]=uiputfile('*.rlf','Save Regressor List File');
save([savepath savefile], 'RegressorsFile');

% --- Executes when selected object is changed in buttonpanel_RegressorList.
function buttonpanel_RegressorList_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in buttonpanel_RegressorList
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
clearvars RegressorsFile
disp(eventdata)
global RegList OculomotorStandardList VisualStandardList
switch get(eventdata.NewValue, 'String')
    case 'Visual standard regressors'
        RegList=VisualStandardList;
    case 'Oculomotor standard regressors'
        RegList=OculomotorStandardList;
    case 'Custom list:'
        [loadfile,loadpath,success]=uigetfile({'*.rlf'},'Regressor List File');
        if success==1
            load([loadpath loadfile], '-mat');
            RegressorsFile(:,2:end+1)=RegressorsFile;
            for k=1:size(RegressorsFile,1)
                RegressorsFile(k,1)=strcat(RegressorsFile(k,2), RegressorsFile(k,3), RegressorsFile(k,4), RegressorsFile(k,5));
            end
            emptyCells = cellfun(@isempty,RegressorsFile);
            RegressorsFile(emptyCells)={''};
            RegList=RegressorsFile;
            set(handles.edit_RegFileDisplay,'String',loadfile);
        else
            errordlg('No file selected. Please load an appropriate Regressor list or select a standard list.');
            
        end
    otherwise
        error('Invalid selection. Aborting...')
end
set(handles.listbox_selectMainReg,'String',RegList(:,1));
set(handles.listbox_selectMainReg,'Value',1);

% --- Executes on selection change in listbox_selectMainReg.
function listbox_selectMainReg_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_selectMainReg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global mainR
mainR=get(hObject,'Value');


%ToDo: setMainReg

% Hints: contents = cellstr(get(hObject,'String')) returns listbox_selectMainReg contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_selectMainReg

function settau_Callback(hObject, eventdata, handles) 
% hObject    handle to settau (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global tau
tau=str2double(get(hObject,'String'));
% Hints: get(hObject,'String') returns contents of settau as text
%        str2double(get(hObject,'String')) returns contents of settau as a double


% --- Executes during object creation, after setting all properties.
function settau_CreateFcn(hObject, eventdata, handles)
% hObject    handle to settau (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in chkbox_preciseframesync.
function chkbox_preciseframesync_Callback(hObject, eventdata, handles)
% hObject    handle to chkbox_preciseframesync (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global precisesync
% Hint: get(hObject,'Value') returns toggle state of chkbox_preciseframesync
precisesync=get(hObject,'Value');


function edit_frametime_Callback(hObject, eventdata, handles)
% hObject    handle to edit_frametime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global frameTime
% Hints: get(hObject,'String') returns contents of edit_frametime as text
%        str2double(get(hObject,'String')) returns contents of edit_frametime as a double
frameTime=str2double(get(hObject,'String'));

% --- Executes during object creation, after setting all properties.
function edit_frametime_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_frametime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in chkbox_usepixcorr.
function chkbox_usepixcorr_Callback(hObject, eventdata, handles)
% hObject    handle to chkbox_usepixcorr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global usePixCorr
usePixCorr=get(hObject,'Value');
% Hint: get(hObject,'Value') returns toggle state of chkbox_usepixcorr


function edit_velthr_Callback(hObject, eventdata, handles)
% hObject    handle to edit_velthr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global velocitythresh
velocitythresh=str2num(get(handles.edit_velthr,'String'));
% Hints: get(hObject,'String') returns contents of edit_velthr as text
%        str2double(get(hObject,'String')) returns contents of edit_velthr as a double

% --- Executes during object creation, after setting all properties.
function edit_velthr_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_velthr (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_FDRalpha_Callback(hObject, eventdata, handles)
% hObject    handle to edit_FDRalpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global FDRalpha
FDRalpha=str2double(get(hObject,'String'));
% Hints: get(hObject,'String') returns contents of edit_FDRalpha as text
%        str2double(get(hObject,'String')) returns contents of
%        edit_FDRalpha as a double

% --- Executes during object creation, after setting all properties.
function edit_FDRalpha_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_FDRalpha (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in checkbox_binning.
function checkbox_binning_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_binning (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_binning
global usebinning
usebinning=get(hObject,'Value');


% --- Executes during object creation, after setting all properties.
function listbox_selectMainReg_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_selectMainReg (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function edit_RegFileDisplay_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_RegFileDisplay (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in pushbutton_tilefigs.
function pushbutton_tilefigs_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_tilefigs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
tilefigs;

% --- Executes on button press in closefigures.
function closefigures_Callback(hObject, eventdata, handles)
% hObject    handle to closefigures (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

for i=1:100
    figure(i)
    close
end


% --- Executes on button press in checkbox_autoROIselect.
function checkbox_autoROIselect_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_autoROIselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global automaticROI
automaticROI=get(hObject,'Value');
% Hint: get(hObject,'Value') returns toggle state of checkbox_autoROIselect



function edit_ROIradius_Callback(hObject, eventdata, handles)
% hObject    handle to edit_ROIradius (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global ROIradius
ROIradius=str2double(get(hObject,'String'));
% Hints: get(hObject,'String') returns contents of edit_ROIradius as text
%        str2double(get(hObject,'String')) returns contents of edit_ROIradius as a double


% --- Executes during object creation, after setting all properties.
function edit_ROIradius_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_ROIradius (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox_stimbarplot.
function checkbox_stimbarplot_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_stimbarplot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global showstimbarplot
showstimbarplot=get(hObject,'Value');
% Hint: get(hObject,'Value') returns toggle state of checkbox_stimbarplot


% --- Executes on button press in pushbutton_ReviewVideo.
function pushbutton_ReviewVideo_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_ReviewVideo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global vid2
implay(vid2);


% --- Executes on button press in checkbox_multilayer.
function checkbox_multilayer_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_multilayer (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

switch get(hObject,'Value')
    case 0
        set(handles.edit_numoflayers, 'Enable', 'off');
        set(handles.text17, 'Enable', 'off');
        set(handles.popupmenu_layerselect, 'Enable', 'off');
    case 1
        set(handles.edit_numoflayers, 'Enable', 'on');
        set(handles.text17, 'Enable', 'on');
        set(handles.popupmenu_layerselect, 'Enable', 'on');
end
% Hint: get(hObject,'Value') returns toggle state of checkbox_multilayer



function edit_numoflayers_Callback(hObject, eventdata, handles)
% hObject    handle to edit_numoflayers (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_numoflayers as text
%        str2double(get(hObject,'String')) returns contents of edit_numoflayers as a double

numoflayers=str2double(get(handles.edit_numoflayers,'String'));
set(handles.popupmenu_layerselect, 'String', 1:numoflayers);

% --- Executes during object creation, after setting all properties.
function edit_numoflayers_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_numoflayers (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenu_layerselect.
function popupmenu_layerselect_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_layerselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_layerselect contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_layerselect


% --- Executes during object creation, after setting all properties.
function popupmenu_layerselect_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_layerselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
