function masks = select_polys_3_automatic(inputIm,fignum)

global smoZMap ZthreshFDR automaticROI ROIradius
%select_polys_2
% a function for manually defining masks corresponding to regions of interest (ROIs) within an image
% inputs:
% inputIm = input image on which ROIs will be drawn
% fignum = number figure in ehich image will be plotted
%
% outputs:
% masks = a size(inputIm,1) x size(inputIm,2) x m array where m is the number of manually defined masks.  
% Each mask is a matrix in which pixels within an ROI are = 1 and remaining pixels are = 0



figure(fignum); %open figure
set(gcf, 'Position', get(0,'Screensize')); % Maximize figure. 

clf;
colormap(gray(256));
imagesc(inputIm); %plot the input image in grayscale

grid on
set(gca,'Xtick',[0:10:250],'Ytick',[0:10:250],'Xcolor','g','Ycolor','m') %150310 Kun 

set(gcf,'DefaultTextColor','blue')
set(gcf,'DefaultTextFontSize',18);

%Initialize variables
i=0;
colors=[];
cont = 1;
masks=zeros(1,length(inputIm(:,1,1)), length(inputIm(1,:,1)));
% while cont == 1
while cont >0 % Kun 2017/02/24
    i=i+1;
    axis equal
    figure(fignum)
%     [masks(i,:,:),xi,yi]=roipoly; % calls roipoly in which the user selects a polygonal region of interest, double-clicking on the boundary when finished
if automaticROI==1
    [y,x] = ginput(1); %Ari
x=round(x);
y=round(y);
xi=x-ROIradius:x+ROIradius;
yi=y-ROIradius:y+ROIradius;
clear temp
for jj=1:length(xi)
    for zz=1:length(yi)
        if sqrt((xi(jj)-x)^2+(yi(zz)-y)^2)<=ROIradius
            temp(jj,zz)=1;
        else
            temp(jj,zz)=0;
        end
    end
end


masks(i,xi,yi)=temp;
masks(i,:,:)=reshape(masks(i,:,:), length(masks(i,:,1)),length(masks(i,1,:))).*(abs(smoZMap)>=ZthreshFDR); %only include pixels that have good z score. 

else
        [masks(i,:,:),xi,yi]=roipoly; % calls roipoly in which the user selects a polygonal region of interest, double-clicking on the boundary when finished

end

Xpoints(i,1:length(xi))=xi;
    Ypoints(i,1:length(yi))=yi;
    %     stopp=0;
    if(length(xi)==2)
        save('xi.mat', 'xi');
        'length(xi)'
        length(xi)
        i=i-1;
        %         stopp=1;%break %program breaks if user selects only two points
    else
        colors=add_random_color(colors,.4); %defines a color for drawing the ROI using random_color
        
        %Now draw the identified ROI on the inputIm, labeling each ROI in order
       if automaticROI==1
           temp=reshape(masks(i,:,:),length(masks(1,:,1)),length(masks(1,1,:)));
           temp=edge(temp);
           [indx indy]=find(temp);
           for j=1:length(indx)-1
               hold on
            plot(indy(j),indx(j),'ro','MarkerSize',3, 'MarkerFaceColor',[1 0 0])
%                L1=line([indx(j) indx(j+1)],[indy(j) indy(j+1)]);
%             set(L1,'Color',colors(:,i));
%             set(L1,'LineWidth',2);
        end
       else
        for j=1:length(xi)-1
            L1=line([xi(j) xi(j+1)],[yi(j) yi(j+1)]);
            set(L1,'Color',colors(:,i));
            set(L1,'LineWidth',2);
        end
       end
% % % %         figure(1)
% % % %         for j=1:length(xi)-1
% % % %             L1=line([xi(j) xi(j+1)],[yi(j) yi(j+1)]);
% % % %             set(L1,'Color',colors(:,i));
% % % %             set(L1,'LineWidth',2);
% % % %         end
% % % %         figure(fignum)
        [xx,yy]=meshgrid(1:size(inputIm,1),size(inputIm,2):-1:1);
        %     thismask=find(squeeze(permute(masks(i,:,:),[2 1]))==1);
        temp=masks(i,:,:);
        temp=reshape(temp,length(masks(i,:,1)),length(masks(i,1,:)));
        [indy indx]=find(temp);
        thismask=find(squeeze((masks(i,:,:)))==1);
        H=text(indx(round(end/2)),indy(round(end/2)),sprintf('%d',i));
        set(H,'HorizontalAlignment','center');
        set(H,'FontSize',18);
        set(H,'Color','g');
%         figure(1)
%         H=text(indx(round(end/2)),indy(round(end/2)),sprintf('%d',i));
%         set(H,'HorizontalAlignment','center');
%         set(H,'FontSize',18);
%         set(H,'Color','g');
%         figure(fignum)
    end
    cont = input('Outline Another ROI? (1 = yes, 0 = no)')
end
masks=masks(1:i,:,:);